<template>
  <v-card outlined flat class="mt-2 panel">
    <v-row class="pl-5 pr-5 mt-3"> </v-row>
    <v-row class="pl-5 pr-5">
      <v-col sm="2">
        <v-select
          v-model="statusId"
          label="Statusi"
          outlined
          dense
          :items="statuses"
          item-value="status_id"
          item-text="status"
          clearable
          @change="fetchData"
        />
      </v-col>
      <v-col sm="2">
        <v-select
          v-model="documentType"
          label="Tipi i dokumentit"
          outlined
          dense
          :items="documentTypes"
          clearable
          @change="fetchData"
        />
      </v-col>
      <v-spacer />
      <v-col sm="4">
        <search-input v-model="search" />
      </v-col>
    </v-row>
    <v-data-table
      dense
      :headers="headers"
      :items="data"
      :loading="loading"
      :options.sync="pagination"
      :server-items-length="totalRecords"
      :footer-props="{
        'items-per-page-options': [5, 10, 15],
      }"
      outlined
    >
      <template v-slot:item="row">
        <tr>
          <td>{{ row.item.id }}</td>
          <td>{{ row.item.full_name }}</td>
          <td>{{ row.item.value }}</td>
          <td>{{ row.item.unreconciled_value }}</td>
          <td>{{ row.item.currency }}</td>
          <td>{{ row.item.notes }}</td>
          <td>{{ row.item.date }}</td>
          <td>
            <v-chip
              class="ma-2 status"
              :color="statusColor(row.item.status_id)"
              small
            >
              {{ statusName(row.item.status_id) }}
            </v-chip>
          </td>
          <td>
            <v-btn
              @click="openReceiptList(row.item)"
              title="Shfaq"
              icon
              color="primary"
              depressed
              ><v-icon>mdi-text-box-search-outline</v-icon></v-btn
            >
            <f-edit-btn @click="editReceipt(row.item)" />
            <f-delete-btn
              @click="deleteReceipt(row.item)"
              :disabled="row.item.status_id === 16 || row.item.status_id === 1"
            />
          </td>
        </tr>
      </template>
    </v-data-table>
    <create-client-receipt v-model="showCreateClientReceiptModal" />
    <edit-client-receipt
      v-if="showEditClientReceiptModal"
      v-model="showEditClientReceiptModal"
      :receipt="receipt"
    />
    <delete-client-receipt
      v-model="showDeleteClientReceiptModal"
      :receipt="receipt"
    />
    <v-dialog width="75%" v-model="showReceiptList">
      <receipt-list :receipt="selectedItems" @close="showReceiptList = false" />
    </v-dialog>
    <portal to="destination">
      <div class="portal-wrapper">
        <h3>
          <f-back-btn back :route="backRoute" />
          Klientet |
          <p class="faded">Lista e Mandateve për {{ clientName }}</p>
          <f-action-btn
            icon="mdi-plus"
            @click="showCreateClientReceiptModal = true"
          />
        </h3>
      </div>
    </portal>
  </v-card>
</template>
<script lang="ts">
import Vue from 'vue'
import api from '../../../plugins/api'
import { Component, Mixins } from 'vue-property-decorator'
import Table from '../../../plugins/table'
import eventBus from '../../../plugins/event-bus'
import FActionBtn from '../../../components/buttons/FActionBtn.vue'
import SearchInput from '../../../components/inputs/SearchInput.vue'
import FEditBtn from '../../../components/buttons/FEditBtn.vue'
import FDeleteBtn from '../../../components/buttons/FDeleteBtn.vue'
import FBackBtn from '../../../components/buttons/FBackBtn.vue'
import CreateClientReceipt from '../Components/Receipt/CreateClientReceipt.vue'
import EditClientReceipt from '../Components/Receipt/EditClientReceipt.vue'
import DeleteClientReceipt from '../Components/Receipt/DeleteClientReceipt.vue'
import ReceiptList from '../Components/Receipt/ReceiptList.vue'

const datatableHeader = [
  { text: 'Id', value: 'id', class: 'grey lighten-4' },
  { text: 'Përdoruesi', value: 'full_name', class: 'grey lighten-4' },
  { text: 'Vlera', value: 'value', class: 'grey lighten-4' },
  {
    text: 'Vlera e mbetur',
    value: 'unreconciled_value',
    class: 'grey lighten-4',
  },
  {
    text: 'Monedha',
    value: 'currency',
    sortable: false,
    class: 'grey lighten-4',
  },
  { text: 'Shënime', value: 'notes', sortable: false, class: 'grey lighten-4' },
  { text: 'Data', value: 'date', class: 'grey lighten-4' },
  {
    text: 'Statusi',
    value: 'status_id',
    sortable: false,
    class: 'grey lighten-4',
  },
  {
    text: 'Veprimet',
    value: 'actions',
    sortable: false,
    class: 'grey lighten-4',
  },
]
@Component({
  components: {
    ReceiptList,
    FActionBtn,
    SearchInput,
    FEditBtn,
    FDeleteBtn,
    FBackBtn,
    CreateClientReceipt,
    EditClientReceipt,
    DeleteClientReceipt,
  },
})
export default class ClientReceipts extends Mixins(Table) {
  headers = datatableHeader
  showReceiptList = false
  showCreateClientReceiptModal = false
  showEditClientReceiptModal = false
  showDeleteClientReceiptModal = false
  selectedItems = []
  receipt = {}
  statusId = null
  documentType = null
  backRoute = 'Clients'
  statuses = [
    { status_id: 15, status: 'Draft' },
    { status_id: 16, status: 'Confirm' },
    { status_id: 1, status: 'Reconciled' },
  ]
  documentTypes = ['MA', 'MAB', 'MAC']
  filters = [
    {
      prop: 'search',
      value: '',
    },
  ]

  get clientName() {
    return this.$route.params.clientName
  }
  statusColor(statusId) {
    let color = ''
    switch (statusId) {
      case 1:
        color = 'orange'
        break
      case 15:
        color = '#1867c0'
        break
      case 16:
        color = '#9acb34'
        break
    }
    return color
  }
  statusName(statusId) {
    let name = ''
    switch (statusId) {
      case 1:
        name = 'Rekonsiluar'
        break
      case 15:
        name = 'Draft'
        break
      case 16:
        name = 'Konfirmuar'
        break
    }
    return name
  }
  openReceiptList(item) {
    console.log('item', item)
    this.selectedItems = item
    this.showReceiptList = true
  }
  goBack() {
    this.$router.go(-1)
  }
  prepareQueryParams() {
    const queryParams: any = {}

    if (this.statusId) {
      queryParams['status_id'] = this.statusId
    }

    if (this.documentType) {
      queryParams['document_type'] = this.documentType
    }

    this.filters.forEach(filter => {
      if (filter.prop === 'search' && filter.value.length > 0) {
        const searchString = encodeURI(filter.value)
        queryParams.qs = `${searchString}`
      }
    })
    return queryParams
  }
  fetchData() {
    const id = this.$route.params.id
    const query = this.prepareQuery(this.prepareQueryParams())
    this.loading = true
    api()
      .get(`/api/crm/clients/${id}/receipts/${query}`)
      .then(response => {
        this.data = response.data.data
        this.totalRecords = response.data.meta.total
      })
      .finally(() => {
        this.loading = false
      })
  }
  editReceipt(receipt) {
    this.showEditClientReceiptModal = true
    this.receipt = receipt
  }
  deleteReceipt(receipt) {
    this.showDeleteClientReceiptModal = true
    this.receipt = receipt
  }
  mounted() {
    eventBus.$on('refresh', () => {
      this.fetchData()
    })
  }
  beforeDestroy() {
    eventBus.$off('refresh')
  }
}
</script>

<style scoped>
.status {
  color: #fff;
  width: 100px;
  display: flex;
  justify-content: center;
}
.faded {
  display: inline;
  color: gray;
}
</style>
